package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.TaskThread;
import be.iminds.ilabt.jfed.highlevel.jobs.states.JobStateFactory;
import be.iminds.ilabt.jfed.highlevel.tasks.HighLevelTaskFactory;
import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Nonnull;
import java.util.Collection;

/**
 * User: twalcari
 * Date: 11/27/2015
 * Time: 16:58
 */
public class EditSshKeysJob extends AbstractJob<Void> {
    private static final Logger LOG = LoggerFactory.getLogger(EditSshKeysJob.class);

    @Nonnull private final Collection<UserSpec> userSpecs;


    @Nonnull private final JobStateFactory jobStateFactory;

    public EditSshKeysJob(@Nonnull Experiment experiment, @Nonnull Collection<UserSpec> userSpecs,
                          @Nonnull HighLevelTaskFactory hltf, @Nonnull TaskThread tt,
                          @Nonnull JobStateFactory jobStateFactory) {
        super("Edit SSH keys in " + experiment.getName(), experiment, hltf, tt);
        this.userSpecs = userSpecs;
        this.jobStateFactory = jobStateFactory;
    }

    @Override
    public Void execute() throws Exception {
        if (userSpecs != null && userSpecs.isEmpty()) {
            setAndRunState(jobStateFactory.createUpdateSshKeysState(EditSshKeysJob.this, userSpecs));
        } else {
            LOG.warn("There were no SSH keys to edit!");
        }

        return null;
    }
}
